image:
  repository: registry.gitlab.com/gitlab-org/build/cng/gitlab-container-registry
  tag: 'v4.16.0-gitlab'
  # pullPolicy: IfNotPresent
  # pullSecrets: []

deployment:
  terminationGracePeriodSeconds: 30
  readinessProbe:
    enabled: true
    path: '/debug/health'
    # defaults to the debug port
    port:
    initialDelaySeconds: 5
    periodSeconds: 5
    timeoutSeconds: 1
    successThreshold: 1
    failureThreshold: 3
  livenessProbe:
    enabled: true
    path: '/debug/health'
    # defaults to the debug port
    port:
    initialDelaySeconds: 5
    periodSeconds: 10
    timeoutSeconds: 1
    successThreshold: 1
    failureThreshold: 3

  # strategy is utilized to configure the desired upgrade approach and
  # configuration for the deployment.  See the Kubernetes documentation
  # related to this subject.
  # https://kubernetes.io/docs/concepts/workloads/controllers/deployment/#strategy
  strategy: {}

podLabels: {}
common:
  labels: {}

serviceLabels: {}
service:
  name: registry
  type: ClusterIP
  externalPort: 5000
  internalPort: 5000
  clusterIP:
  loadBalancerIP:

## Support for tolerations for pod scheduling
tolerations: []

# Priority class assigned to pods
priorityClassName: ""

## Enable/Disable Chart
enabled: true

## Registry Maintenance Settings
## See https://docs.docker.com/registry/configuration/#maintenance
maintenance:
  readonly:
    ## Enable read-only mode for Registry
    enabled: false
  uploadpurging:
    enabled: true
    age: 168h
    interval: 24h
    dryrun: false

annotations: {}

networkpolicy:
  enabled: false
  egress:
    enabled: false
    rules: []
  ingress:
    enabled: false
    rules: []
  annotations: {}

ingress:
  apiVersion:
  enabled:
  proxyReadTimeout: 900
  proxyBodySize: "0"
  proxyBuffering: "off"
  tls: {}
    # secretName:
    # enabled: true
  annotations: {}
  configureCertmanager:
  path: # /

global:
  ingress:
    enabled:
    annotations: {}
    tls: {}
      # secretName:
      # enabled: true
  hosts:
    domain: example.com
    hostSuffix:
    https: true
    tls: {}
      # secretName:
    gitlab: {}
      #name: gitlab.example.com
      #https: false
    registry: {}
      #name: registry.example.com
      #https: false
    minio: {}
      #name: minio.example.com
      #https: false
  minio:
    enabled:
    credentials: {}
  registry:
    certificate: {}
    httpSecret: {}
  psql:
    ssl: {}

## Control the InitContainer behaviors.
init:
  image: {}
    # repository:
    # tag:
    # pullPolicy: IfNotPresent
  resources:
    requests:
      cpu: 50m
  containerSecurityContext:
    runAsUser: 1000
    allowPrivilegeEscalation: false
    runAsNonRoot: true
    capabilities:
      drop: [ "ALL" ]
  script: |-
    if [ -e /config/accesskey ] ; then
      sed -i -e 's@ACCESS_KEY@'"$(cat /config/accesskey)"'@' -e 's@SECRET_KEY@'"$(cat /config/secretkey)"'@' /registry/config.yml
    fi
    # Place the `http.secret` value from the kubernetes secret
    sed -i -e 's@HTTP_SECRET@'"$(cat /config/httpSecret)"'@' /registry/config.yml
    # Populate sensitive registry notification secrets in the config file
    if [ -d /config/notifications ]; then
      for i in /config/notifications/*; do
        filename=$(basename $i);
        sed -i -e 's@'"${filename}"'@'"$(cat $i)"'@' /registry/config.yml;
      done
    fi
    # Insert any provided `storage` block from kubernetes secret
    if [ -d /config/storage ]; then
      # Copy contents of storage secret(s)
      mkdir -p /registry/storage
      cp -v -r -L /config/storage/* /registry/storage/
      # Ensure there is a new line in the end
      echo '' >> /registry/storage/config
      # Default `delete.enabled: true` if not present.
      ## Note: busybox grep doesn't support multiline, so we chain `egrep`.
      if ! $(egrep -A1 '^delete:\s*$' /registry/storage/config | egrep -q '\s{2,4}enabled:') ; then
        echo 'delete:' >> /registry/storage/config
        echo '  enabled: true' >> /registry/storage/config
      fi
      # Indent /registry/storage/config 2 spaces before inserting into config.yml
      sed -i 's/^/  /' /registry/storage/config
      # Insert into /registry/config.yml after `storage:`
      sed -i '/^storage:/ r /registry/storage/config' /registry/config.yml
      # Remove the now extraneous `config` file
      rm /registry/storage/config
    fi
    # Copy any middleware.storage if present
    if [ -d /config/middleware.storage ]; then
      cp -v -r -L /config/middleware.storage  /registry/middleware.storage
    fi
    # Set to known path, to used ConfigMap
    cat /config/certificate.crt > /registry/certificate.crt
    # Copy the optional profiling keyfile to the expected location
    if [ -f /config/profiling-key.json ]; then
      cp /config/profiling-key.json /registry/profiling-key.json
    fi
    # Insert Database password, if enabled
    if [ -f /config/database_password ] ; then
      sed -i -e 's@DB_PASSWORD_FILE@'"$(cat /config/database_password)"'@' /registry/config.yml
    fi
    # Insert Redis(cache) password, if enabled
    if [ -f /config/registry/redis-password ] ; then
      sed -i -e 's@REDIS_CACHE_PASSWORD@'"$(cat /config/registry/redis-password)"'@' /registry/config.yml
    fi
    # Insert Redis(rate-limiter) password, if enabled
    if [ -f /config/registry/redis-rateLimiting-password ] ; then
      sed -i -e 's@REDIS_RATE_LIMITING_PASSWORD@'"$(cat /config/registry/redis-rateLimiting-password)"'@' /registry/config.yml
    fi
    # Copy the database TLS connection files to the expected location and set permissions
    if [ -d /config/ssl ]; then
      cp -r /config/ssl/ /registry/ssl
      chmod 700 /registry/ssl
      chmod 600 /registry/ssl/*.pem
    fi
    # Copy TLS certificates if present
    if [ -d /config/tls ]; then
      cp -r /config/tls/ /registry/tls
      chmod 700 /registry/tls
      chmod 600 /registry/tls/*
    fi

# define some sane resource requests and limitations
resources:
  # limits:
  #   cpu: 200m
  #   memory: 1024Mi
  requests:
    cpu: 50m
    memory: 32Mi

## Node labels for pod assignment
## ref: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/#nodeselector
nodeSelector: {}

affinity:
  podAntiAffinity:
    topologyKey:
  nodeAffinity:
    key:
    values:

# Protocol/Host only. '/jwt/auth' will be appended.
authEndpoint:
# Do not change this
tokenService: 'container_registry'
# This must match your GitLab Rails configuration
# tokenIssuer: 'gitlab-issuer'

# Must to be `false` to support Windows clients
# See https://gitlab.com/gitlab-org/omnibus-gitlab/-/issues/3964
authAutoRedirect: false

maxUnavailable: 1

# if minReplicas is >1, shared storage MUST be used.
hpa:
  minReplicas: 2
  maxReplicas: 10
  cpu:
    targetType: Utilization  # Utilization or AverageValue
    # targetAverageValue: 1
    targetAverageUtilization: 75
  # memory:
  #   targetType: Utilization  # Utilization or AverageValue
  #   targetAverageValue: 1G
  #   targetAverageUtilization: 75
  # Note that the HPA is limited to autoscaling/v2beta1, autoscaling/v2beta2 and autoscaling/v2
  customMetrics: []  # Overrides HPA metrics definition
  behavior:
    scaleDown:
      stabilizationWindowSeconds: 300

keda:
  enabled: false
  ## See https://keda.sh/docs/2.10/concepts/scaling-deployments/#scaledobject-spec
  pollingInterval: 30
  cooldownPeriod: 300
  # minReplicaCount: 2
  # maxReplicaCount: 10
  # fallback: {}
  #   failureThreshold: 3
  #   replicas: 6
  # hpaName: keda-hpa-{scaled-object-name}
  # restoreToOriginalReplicaCount: false
  # behavior: {}
  # triggers: []

storage: {}
# secret:
# redirect:
#   disable:
#   exceptions: []
middleware:
  # See https://gitlab.com/gitlab-org/container-registry/-/blob/master/docs/configuration.md#middleware
  storage: []
    ## EXAMPLE ONLY
    # - name: cloudfront
    #   options:
    #     baseurl: cdn.registry.example.com
    #     # `privatekey` is auto-populated with the content from the privatekey Secret.
    #     privatekeySecret:
    #       secret: cdn-private-key
    #       key: private.pem
    #     keypairid: YOURKEYPAIRIDFORPRIVATEKEY

minio:
  redirect: false

# Enable the registry to accept windows based docker images
# See https://github.com/docker/distribution/issues/2795
validation:
  disabled: true
  manifests:
    referencelimit: 0
    payloadsizelimit: 0
    urls:
      allow: []
      deny: []

# Configure the logging mechanism for the Container Registry as desired
# See https://docs.docker.com/registry/configuration/#log
log:
  level: info
  fields:
    service: registry

debug:
  addr:
    port: 5001
  tls:
    enabled: false
    secretName: # Kubernetes secret, type kubernetes.io/tls
    clientCAs: []
    minimumTLS: "tls1.2"
  # DEPRECATED in favor of `metrics`
  prometheus:
    enabled: false
    path:

# The debug.addr.port is used for metrics
metrics:
  enabled: false
  path: /metrics
  serviceMonitor:
    enabled: false
    additionalLabels: {}
    endpointConfig: {}

# Amount of time to wait for HTTP connections to drain after
# receiving a SIGTERM signal
draintimeout: '0'

# Enable the registry to return relative URLs in Location headers
relativeurls: false

# https://docs.docker.com/registry/configuration/#health
health:
  storagedriver:
    enabled: false
    interval: 10s
    threshold: 3

## Allow to overwrite under which User and Group the Pod will be running.
securityContext:
  runAsUser: 1000
  fsGroup: 1000
  # fsGroupChangePolicy: OnRootMismatch
  seccompProfile:
    type: "RuntimeDefault"

## Allow to overwrite the specific security context under which the container is running.
containerSecurityContext:
  runAsUser: 1000
  allowPrivilegeEscalation: false
  runAsNonRoot: true
  capabilities:
    drop: [ "ALL" ]

# Disable reporting by default
# https://gitlab.com/gitlab-org/container-registry/-/blob/master/docs/configuration.md#reporting
reporting:
  sentry:
    enabled: false
    # dsn:
    # environment:

# Disable continuous profiling by default
# https://gitlab.com/gitlab-org/container-registry/-/blob/master/docs/configuration.md#profiling
# keyfile is provided via secrets, and serviceversion will be image.tag
profiling:
  stackdriver:
    enabled: false
    credentials: {}

serviceAccount:
  create: false
  ## Used for local override of global ServiceAccount token mounting
  # automountServiceAccountToken: false



# Disable metadata database by default
# Please review the [feedback issue](https://gitlab.com/gitlab-org/gitlab/-/issues/423459)
# and associated documentation before enabling this feature.
# https://gitlab.com/gitlab-org/container-registry/-/blob/master/docs/configuration.md#database
database:
  configure: false
  enabled: false
  user: registry
  password: {}
    # secret: RELEASE_NAME-registry-database-password
    # key: password
  name: registry
  sslmode: disable
  ssl: {}
  # Load balancing settings
  # WARNING: This is an experimental feature and must not be used in production.
  # https://gitlab.com/gitlab-org/container-registry/-/blob/master/docs/configuration.md#loadbalancing
  loadBalancing:
    enabled: false
  migrations:
    enabled: true
    activeDeadlineSeconds: 3600
    backoffLimit: 6
    # Annotations for the job
    annotations: {}
  backgroundMigrations:
    enabled: false

redis:
  # Redis cache to be used in conjunction with the metadata database.
  # NOTE: This is an experimental feature and must not be used in production.
  # https://gitlab.com/gitlab-org/container-registry/-/blob/master/docs/configuration.md#cache-1
  cache:
    enabled: false
    password:
      enabled: false
  # Redis rate-limiter connection settings
  # https://gitlab.com/gitlab-org/container-registry/-/blob/master/docs/configuration.md?ref_type=heads#ratelimiter
  # TODO: add behavior settings https://gitlab.com/gitlab-org/container-registry/-/issues/1224
  rateLimiting:
    enabled: false
    password:
      enabled: false

# The online garbage collector is only going to be enabled if the metadata
# database is enabled. In general, we don't want to default to disabled, since
# online garbage collection is designed to run continuously and should only be
# disabled for compelling debugging and troubleshooting reasons.
# https://gitlab.com/gitlab-org/container-registry/-/blob/master/docs/configuration.md#gc
gc:
  disabled: false

## Configure TLS on the instance itself
## WARNING: All clients must trust the certificate used for service.
tls:
  enabled: false
  secretName: # Kubernetes secret, type kubernetes.io/tls
  clientCAs: []
  minimumTLS: "tls1.2"
  # NGINX Ingress related
  verify: true
  caSecretName: # Kubernetes secret, type Opaque, with `ca.crt` key
  # cipherSuites:
  #   - TLS_ECDHE_ECDSA_AES_128_GCM_SHA256
  #   - TLS_ECDHE_ECDSA_AES_256_GCM_SHA384
  #   - TLS_ECDHE_ECDSA_CHACHA20_POLY1305_SHA256
  #   - TLS_ECDHE_RSA_AES_128_GCM_SHA256
  #   - TLS_ECDHE_RSA_AES_256_GCM_SHA384
  #   - TLS_ECDHE_RSA_CHACHA20_POLY1305_SHA256

## Topology spread constraints rely on node labels to identify the topology domain(s) that each Node is in.
## Ref: https://kubernetes.io/docs/concepts/workloads/pods/pod-topology-spread-constraints/
topologySpreadConstraints: []
 # - labelSelector:
 #     matchLabels:
 #       app: name
 #     maxSkew: 1
 #     topologyKey: topology.kubernetes.io/zone
 #     whenUnsatisfiable: DoNotSchedule
